unit UnitDataGraph;

interface

uses
   Windows, UnitFunc, UnitData, UnitGraph, UnitClipping ;

var
   ScrX, ScrY : integer ;  // ʃTCY(hbg)
   CenX, CenY : integer ;  // ʒ_(hbg)
   mm_dot : double ;       // mmhbgWϊW
   WndX1, WndY1 : double ; // ʍ_(mm)
   WndX2, WndY2 : double ; // ʉE_(mm)
   CData : TDataClass ;
   gp : TGraphClass ;

   procedure ZInit ;
   procedure Z2D(var ix,iy:integer;x,y:double);
   procedure DisplayLayCol1(lay,col:integer;var c,cc:integer);
   procedure DisplayLayCol2(lay,col,ltp,wid:integer;var c,cc,l,w:integer;var ww:double);
   procedure DisplayLineSub1(px1,py1,px2,py2:double);
   procedure DisplayLineSub2(l:integer;var i:integer;var d1:double;px1,py1,px2,py2:double);
   procedure DisplayTenMarker(lay,col,mc:integer;px,py,an,sc:double);
   procedure DisplayLine(lay,col,ltp,wid:integer;px1,py1,px2,py2:double);
   procedure DisplayLines(lay,col,ltp,wid,num:integer;vx,vy:array of double);
   procedure DisplayCircle(lay,col,ltp,wid:integer;px,py,pr:double;t:TMatrix);
   procedure DisplayArc(lay,col,ltp,wid,dir:integer;px,py,pr,sa,ea:double;t:TMatrix);
   procedure DisplayEllipse(lay,col,ltp,wid:integer;px,py,rx,ry,ra:double;t:TMatrix);
   procedure DisplayEllipseArc(lay,col,ltp,wid,dir:integer;px,py,rx,ry,ra,sa,ea:double;t:TMatrix);
   procedure DisplayAllData ;

implementation

// ֘Aeϐ̏
//    in ScrX,ScrY ;
procedure ZInit ;
var
   mx,my : double ;
begin
   mx := (ScrX - 4)/CData.zp.x ;
   my := (ScrY - 4)/CData.zp.y ;
   if (mx < my) then
      mm_dot := mx
   else
      mm_dot := my ;

   CenX := ScrX div 2;    // ʒ
   CenY := ScrY div 2;

   // ʍ_
   WndX1 := CData.zp.x/2.0 + (0        - CenX)/mm_dot ;
   WndY1 := CData.zp.y/2.0 - ((ScrY-1) - CenY)/mm_dot ;
   // ʉE_
   WndX2 := CData.zp.x/2.0 + ((ScrX-1) - CenX)/mm_dot ;
   WndY2 := CData.zp.y/2.0 - (0        - CenY)/mm_dot ;
end;

// pmmWʃhbgW
procedure Z2D(var ix,iy:integer;x,y:double);
begin
{
   ix := Trunc(CenX + (x - CData.zp.x/2.0)*mm_dot) ;
   iy := Trunc(CenY - (y - CData.zp.y/2.0)*mm_dot) ;
}
   ix := Trunc( (x - WndX1)*mm_dot) ;
   iy := Trunc(-(y - WndY2)*mm_dot) ;

   // 킹獶㍇킹ɕύXĂ܂(test-018)
end;

// F̕\ETu
// (in)
//    lay: C(1-256)
//    col: F@(0,1-256) -1:w肵Ȃ
// (out)
//    c : F   (1-256)
//    cc: RGBF
procedure DisplayLayCol1(lay,col:integer;var c,cc:integer);
begin
   if (col >= 0) then begin
      c := col ;
      if (c = 0) then c := CData.zLay[lay-1].Color ;
      cc:= RGB(CData.zCol[c-1].Red,CData.zCol[c-1].Green,CData.zCol[c-1].Blue);
      gp.G_SetPen(cc);
   end;
end;

// FEE̕\ETu
// (in)
//    lay: C(1-256)
//    col: F@(0,1-256) -1:w肵Ȃ
//    ltp: (0,1-32)  -1:w肵Ȃ
//    wid: (0,1-16)  -1:w肵Ȃ
// (out)
//    c : F   (1-256)
//    cc: RGBF
//    l :  (1-32)
//    w :  (1-16)
//    ww:  [dot]
procedure DisplayLayCol2(lay,col,ltp,wid:integer;var c,cc,l,w:integer;var ww:double);
begin
   DisplayLayCol1(lay,col,c,cc);    // F
   if (ltp >= 0) then begin
      l := ltp ;
      if (l = 0) then l := CData.zLay[lay-1].Ltype ;
      // ۂ̐̕`́ADisplayLineSub2()ōs
   end;
   if (wid >= 0) then begin
      w := wid ;
      if (w = 0) then w := CData.zLay[lay-1].Width ;
      ww := CData.zWid[w-1].Width * mm_dot ;
      if (ww <   1.0) then ww :=   1.0 ;
      if (ww > 500.0) then ww := 500.0 ;
      gp.G_SetWidth(Round(ww));
   end;
end;

// ̕\ETuPF
//    px1,py1 : n_[mm]
//    px2,py2 : I_[mm]
//    FE͊Ɏw肵Ă鎖
procedure DisplayLineSub1(px1,py1,px2,py2:double);
var
   x1,y1,x2,y2 : integer ;
begin
   if (ClipLine(px1,py1,px2,py2, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   Z2D(x1,y1, px1,py1);
   Z2D(x2,y2, px2,py2);
   gp.G_Line(x1,y1,x2,y2);
end;

// ̕\ETuQFw
//    l : ԍ(1-)
//    i : JnZOgԍ(IXV)
//    d1: Jnsb`@@(IXV)
//    px1,py1 : n_[mm]
//    px2,py2 : I_[mm]
//    FE͊Ɏw肵Ă鎖
procedure DisplayLineSub2(l:integer;var i:integer;var d1:double;px1,py1,px2,py2:double);
var
   x1,y1,x2,y2 : integer ;
   a,sa,ca,d,p,wx1,wy1,wx2,wy2 : double ;
   fl : Boolean ;
begin
   if (ClipLine(px1,py1,px2,py2, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   a := Angle(px2-px1, py2-py1);
   d := Dist(px1,py1, px2,py2);
   ca:= Cos(a);
   sa:= Sin(a);
   wx1:= px1 ;
   wy1:= py1 ;
   fl := True ;
   while(fl) do begin
   	p := CData.zLtp[l-1].Pitch[i] - d1 ;
      if (p > d) then p := d ;
      wx2 := wx1 + p*ca ;
      wy2 := wy1 + p*sa ;
      if ((i mod 2) = 0) then begin
         Z2D(x1,y1, wx1,wy1);
         Z2D(x2,y2, wx2,wy2);
         gp.G_Line(x1,y1,x2,y2);
      end;
      wx1 := wx2 ;
      wy1 := wy2 ;
      d := d - p ;
      if (d <= LIMIT8) then begin
      	fl := False ;
      	d1 := d1 + p ;
      end
      else begin
     		d1 := 0.0 ;
         Inc(i);
         if (i >= CData.zLtp[l-1].Segment) then i:=0;
      end;
   end;
end;

// _}[J̕\
//    an : ]p[rad]
procedure DisplayTenMarker(lay,col,mc:integer;px,py,an,sc:double);
const
   DOT_SIZE = 5 ;    // _}[Jdot̑傫ialj
var
   c,cc : integer ;
   sz : double ;
   w1,w2,w3,w4,w5,w6 : double ;
   x1,y1 : integer ;
   // i1 : integer ;
   e : TMatrix ;
begin
   // _}[JENbsO`FbN
   if (mc = 3) then begin
      // dot
      sz := DOT_SIZE/mm_dot ;
   end
   else begin
      // dotȊO
      sz := 2.5*sc*Sqrt(2.0) ;
   end;
   if (Clip1xyPoint(px,py,sz,sz, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   DisplayLayCol1(lay,col,c,cc);    // F
   gp.G_SetWidth(1);
   //
   sz := 2.5/2.0*sc ;
   case(mc)of
   1: begin
         // asterisk
         w5 := px ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(30.0/180.0*Pi) ;
         w6 := py+sz*Sin(30.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(210.0/180.0*Pi) ;
         w6 := py+sz*Sin(210.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(150.0/180.0*Pi) ;
         w6 := py+sz*Sin(150.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(330.0/180.0*Pi) ;
         w6 := py+sz*Sin(330.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   2: begin
         // circle
         {
         Z2D(x1,y1, px,py);
         i1 := Trunc(sz*mm_dot);
         gp.G_Circle(x1,y1,i1);
         }
         MtxSetE(e);
         DisplayCircle(lay,col,1,1, px,py,sz,e);
      end;
   3: begin
         // dot
         Z2D(x1,y1, px,py);
         gp.G_CircleF(x1,y1,DOT_SIZE);
      end;
   4: begin
         // plus
         w5 := px-sz ;
         w6 := py ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz ;
         w6 := py ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   5: begin
         // square
         w5 := px-sz ;
         w6 := py-sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz ;
         w6 := py-sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz ;
         w6 := py+sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px-sz ;
         w6 := py+sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px-sz ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px-sz ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   6: begin
         // triangle
         sz := 2.5*2.0/3.0*sc ;
         w5 := px+sz*Cos(90.0/180.0*Pi) ;
         w6 := py+sz*Sin(90.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(210.0/180.0*Pi) ;
         w6 := py+sz*Sin(210.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(210.0/180.0*Pi) ;
         w6 := py+sz*Sin(210.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(330.0/180.0*Pi) ;
         w6 := py+sz*Sin(330.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px+sz*Cos(330.0/180.0*Pi) ;
         w6 := py+sz*Sin(330.0/180.0*Pi) ;
         Rev(w1,w2, w5,w6, px,py, an);
         w5 := px+sz*Cos(90.0/180.0*Pi) ;
         w6 := py+sz*Sin(90.0/180.0*Pi) ;
         Rev(w3,w4, w5,w6, px,py, an);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   7: begin
         // X
         w5 := px-sz ;
         w6 := py ;
         Rev(w1,w2, w5,w6, px,py, an+0.25*Pi);
         w5 := px+sz ;
         w6 := py ;
         Rev(w3,w4, w5,w6, px,py, an+0.25*Pi);
         DisplayLineSub1(w1,w2,w3,w4);

         w5 := px ;
         w6 := py+sz ;
         Rev(w1,w2, w5,w6, px,py, an+0.25*Pi);
         w5 := px ;
         w6 := py-sz ;
         Rev(w3,w4, w5,w6, px,py, an+0.25*Pi);
         DisplayLineSub1(w1,w2,w3,w4);
      end;
   end;
end;

// ̕\
procedure DisplayLine(lay,col,ltp,wid:integer;px1,py1,px2,py2:double);
var
   c,cc,l,w, i : integer ;
   ww, d1 : double ;
begin
   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then begin
      DisplayLineSub1(px1,py1,px2,py2);
   end
   else begin
      i := 0 ;
      d1:= 0.0;
      DisplayLineSub2(l,i,d1, px1,py1,px2,py2);
   end;
end;

// ܐ̕\
procedure DisplayLines(lay,col,ltp,wid,num:integer;vx,vy:array of double);
var
   c,cc,l,w, i,j : integer ;
   ww, d1 : double ;
begin
   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then begin
      for j:=1 to num-1 do begin
         DisplayLineSub1(vx[j-1],vy[j-1], vx[j],vy[j]);
      end;
   end
   else begin
      i := 0 ;
      d1:= 0.0 ;
      for j:=1 to num-1 do begin
         DisplayLineSub2(l,i,d1, vx[j-1],vy[j-1], vx[j],vy[j]);
      end;
   end;
end;

// ~̕\
procedure DisplayCircle(lay,col,ltp,wid:integer;px,py,pr:double;t:TMatrix);
const
   ARC_LENGTH = 15.0 ;  // Ԑ[dotl]
   ARC_MIN = 8 ;
   ARC_MAX = 360 ;
var
   c,cc,l,w, i,j : integer ;
   ww, d1, a,aa,n, x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   fl : Boolean ;
begin
   // ~ENbsO`FbN
   x1 := px-pr;   y1 := py-pr;   MtxXY(x1,y1, x1,y1, t);
   x2 := px+pr;   y2 := py-pr;   MtxXY(x2,y2, x2,y2, t);
   x3 := px+pr;   y3 := py+pr;   MtxXY(x3,y3, x3,y3, t);
   x4 := px-pr;   y4 := py+pr;   MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   x1 := 0.0 ;
   y1 := 0.0 ;
   x2 := pr*Cos(0.25*Pi) ;
   y2 := pr*Sin(0.25*Pi) ;
   MtxXY(x1,y1, x1,y1, t);
   MtxXY(x2,y2, x2,y2, t);
   d1 := Dist(x1,y1,x2,y2);
   a := ARC_LENGTH / (d1 * mm_dot) ;
   n := Int(2.0*Pi/a) ;
   if (n < ARC_MIN) then n := ARC_MIN ;
   if (n > ARC_MAX) then n := ARC_MAX ;
   a := 2.0*Pi / n ;

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   fl := False ;
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then
      fl := True ;

   i  := 0 ;
   d1 := 0.0 ;
   aa := 0.0 ;
   x1 := px + pr*Cos(aa);
   y1 := py + pr*Sin(aa);
   MtxXY(x1,y1, x1,y1, t);
   for j:=1 to Round(n) do begin
      aa := aa + a;
      x2 := px + pr*Cos(aa);
      y2 := py + pr*Sin(aa);
      MtxXY(x2,y2, x2,y2, t);
      if (fl) then
         DisplayLineSub1(x1,y1,x2,y2)
      else
         DisplayLineSub2(l,i,d1, x1,y1,x2,y2) ;
      x1 := x2 ;
      y1 := y2 ;
   end;
end;

// ~ʂ̕\
procedure DisplayArc(lay,col,ltp,wid,dir:integer;px,py,pr,sa,ea:double;t:TMatrix);
const
   ARC_LENGTH = 15.0 ;  // Ԑ[dotl]
   ARC_MIN = 8 ;
   ARC_MAX = 360 ;
var
   c,cc,l,w, i,j : integer ;
   ww, d1, a,aa,n, x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   fl : Boolean ;
begin
   // ~ENbsO`FbN
   x1 := px-pr;   y1 := py-pr;   MtxXY(x1,y1, x1,y1, t);
   x2 := px+pr;   y2 := py-pr;   MtxXY(x2,y2, x2,y2, t);
   x3 := px+pr;   y3 := py+pr;   MtxXY(x3,y3, x3,y3, t);
   x4 := px-pr;   y4 := py+pr;   MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   if (dir <> 0) then swapD(sa,ea);
   aa := ea - sa ;
   if (aa < 0.0) then aa := aa + 360.0 ;
   if (dir <> 0) then begin
      swapD(sa,ea);
      aa := -aa ;
   end;

   x1 := 0.0 ;
   y1 := 0.0 ;
   x2 := pr*Cos(0.25*Pi) ;
   y2 := pr*Sin(0.25*Pi) ;
   MtxXY(x1,y1, x1,y1, t);
   MtxXY(x2,y2, x2,y2, t);
   d1 := Dist(x1,y1,x2,y2);
   a := ARC_LENGTH / (d1 * mm_dot) ;
   n := Int(Abs(aa)/180.0*Pi/a) ;
   if (n < ARC_MIN) then n := ARC_MIN ;
   if (n > ARC_MAX) then n := ARC_MAX ;
   a := aa/180.0*Pi / n ;

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   fl := False ;
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then
      fl := True ;

   i  := 0 ;
   d1 := 0.0 ;
   aa := sa/180.0*Pi ;
   x1 := px + pr*Cos(aa);
   y1 := py + pr*Sin(aa);
   MtxXY(x1,y1, x1,y1, t);
   for j:=1 to Round(n) do begin
      aa := aa + a;
      x2 := px + pr*Cos(aa);
      y2 := py + pr*Sin(aa);
      MtxXY(x2,y2, x2,y2, t);
      if (fl) then
         DisplayLineSub1(x1,y1,x2,y2)
      else
         DisplayLineSub2(l,i,d1, x1,y1,x2,y2) ;
      x1 := x2 ;
      y1 := y2 ;
   end;
end;

// ȉ~̕\
procedure DisplayEllipse(lay,col,ltp,wid:integer;px,py,rx,ry,ra:double;t:TMatrix);
const
   ARC_LENGTH = 15.0 ;  // Ԑ[dotl]
   ARC_MIN = 8 ;
   ARC_MAX = 360 ;
var
   c,cc,l,w, i,j : integer ;
   ww, d1, a,aa,n, x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   fl : Boolean ;
   tr,tr1 : TMatrix ;
begin
   // ȉ~ENbsO`FbN
   MtxMove(tr, -px,-py);
   MtxRotD(tr1,ra);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, px,py);
   tr := MtxMult(tr,tr1) ;
   t  := MtxMult(tr,t) ;
   x1 := px-rx;   y1 := py-ry;   MtxXY(x1,y1, x1,y1, t);
   x2 := px+rx;   y2 := py-ry;   MtxXY(x2,y2, x2,y2, t);
   x3 := px+rx;   y3 := py+ry;   MtxXY(x3,y3, x3,y3, t);
   x4 := px-rx;   y4 := py+ry;   MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   x1 := 0.0 ;
   y1 := 0.0 ;
   x2 := rx*Cos(0.25*Pi) ;
   y2 := ry*Sin(0.25*Pi) ;
   MtxXY(x1,y1, x1,y1, t);
   MtxXY(x2,y2, x2,y2, t);
   d1 := Dist(x1,y1,x2,y2);
   a := ARC_LENGTH / (d1 * mm_dot) ;
   n := Int(2.0*Pi/a) ;
   if (n < ARC_MIN) then n := ARC_MIN ;
   if (n > ARC_MAX) then n := ARC_MAX ;
   a := 2.0*Pi / n ;

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   fl := False ;
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then
      fl := True ;

   i  := 0 ;
   d1 := 0.0 ;
   aa := 0.0 ;
   x1 := px + rx*Cos(aa);
   y1 := py + ry*Sin(aa);
   MtxXY(x1,y1, x1,y1, t);
   for j:=1 to Round(n) do begin
      aa := aa + a;
      x2 := px + rx*Cos(aa);
      y2 := py + ry*Sin(aa);
      MtxXY(x2,y2, x2,y2, t);
      if (fl) then
         DisplayLineSub1(x1,y1,x2,y2)
      else
         DisplayLineSub2(l,i,d1, x1,y1,x2,y2) ;
      x1 := x2 ;
      y1 := y2 ;
   end;
end;

// ȉ~ʂ̕\
procedure DisplayEllipseArc(lay,col,ltp,wid,dir:integer;px,py,rx,ry,ra,sa,ea:double;t:TMatrix);
const
   ARC_LENGTH = 15.0 ;  // Ԑ[dotl]
   ARC_MIN = 8 ;
   ARC_MAX = 360 ;
var
   c,cc,l,w, i,j : integer ;
   ww, d1, a,aa,n, x1,y1,x2,y2,x3,y3,x4,y4 : double ;
   fl : Boolean ;
   tr,tr1 : TMatrix ;
begin
   // ȉ~ENbsO`FbN
   MtxMove(tr, -px,-py);
   MtxRotD(tr1,ra);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, px,py);
   tr := MtxMult(tr,tr1) ;
   t  := MtxMult(tr,t) ;
   x1 := px-rx;   y1 := py-ry;   MtxXY(x1,y1, x1,y1, t);
   x2 := px+rx;   y2 := py-ry;   MtxXY(x2,y2, x2,y2, t);
   x3 := px+rx;   y3 := py+ry;   MtxXY(x3,y3, x3,y3, t);
   x4 := px-rx;   y4 := py+ry;   MtxXY(x4,y4, x4,y4, t);
   if (Clip4Point(x1,y1,x2,y2,x3,y3,x4,y4, WndX1,WndY1,WndX2,WndY2) = 2) then exit;

   if (dir <> 0) then swapD(sa,ea);
   aa := ea - sa ;
   if (aa < 0.0) then aa := aa + 360.0 ;
   if (dir <> 0) then begin
      swapD(sa,ea);
      aa := -aa ;
   end;

   x1 := 0.0 ;
   y1 := 0.0 ;
   x2 := rx*Cos(0.25*Pi) ;
   y2 := ry*Sin(0.25*Pi) ;
   MtxXY(x1,y1, x1,y1, t);
   MtxXY(x2,y2, x2,y2, t);
   d1 := Dist(x1,y1,x2,y2);
   a := ARC_LENGTH / (d1 * mm_dot) ;
   n := Int(Abs(aa)/180.0*Pi/a) ;
   if (n < ARC_MIN) then n := ARC_MIN ;
   if (n > ARC_MAX) then n := ARC_MAX ;
   a := aa/180.0*Pi / n ;

   DisplayLayCol2(lay,col,ltp,wid, c,cc,l,w,ww);   // FEE
   //
   fl := False ;
   if (CData.zLtp[l-1].Segment = 0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < 2.0)
    or(CData.zLtp[l-1].SpaceMax * mm_dot < ww ) then
      fl := True ;

   i  := 0 ;
   d1 := 0.0 ;
   aa := sa/180.0*Pi ;
   x1 := px + rx*Cos(aa);
   y1 := py + ry*Sin(aa);
   MtxXY(x1,y1, x1,y1, t);
   for j:=1 to Round(n) do begin
      aa := aa + a;
      x2 := px + rx*Cos(aa);
      y2 := py + ry*Sin(aa);
      MtxXY(x2,y2, x2,y2, t);
      if (fl) then
         DisplayLineSub1(x1,y1,x2,y2)
      else
         DisplayLineSub2(l,i,d1, x1,y1,x2,y2) ;
      x1 := x2 ;
      y1 := y2 ;
   end;
end;



// Sf[^\
procedure DisplayAllData ;
var
   o,o1,o2, i,j,k : integer ;
   lx1,ly1,lx2,ly2,lx3,ly3 : double ;
   an : double ;
   lx,ly : array of double ;
   e : TMatrix ;
begin
   MtxSetE(e);
   // \Lvf^p@ef[^\
   for o:=0 to CData.dOrdN-1 do begin
      o1 := CData.dOrd[o].DataType ;
      o2 := CData.dOrd[o].DataNo ;
      case (o1) of
      1: begin
            // _}[JEf[^\
            with CData.dTen[o2] do begin
               an := rotate_angle/180.0*Pi ;
               DisplayTenMarker(Layer,Color,marker_code,start_x,start_y,an,Scale);
            end;
         end;
      2: begin
            // f[^\
            with CData.dLin[o2] do begin
               DisplayLine(Layer,Color,Ltype,line_width,start_x,start_y,end_x,end_y);
            end;
         end;
      3: begin
            // ܐf[^\eXg
            with CData.dLns[o2] do begin
               DisplayLines(Layer,Color,Ltype,line_width,Number,X,Y);
            end;
         end;
      4: begin
            // ~f[^\
            with CData.dCir[o2] do begin
               DisplayCircle(Layer,Color,Ltype,line_width,Center_x,Center_y,Radius,e);
            end;
         end;
      5: begin
            // ~ʃf[^\
            with CData.dArc[o2] do begin
               DisplayArc(Layer,Color,Ltype,line_width,Direction,Center_x,Center_y,Radius,start_angle,end_angle,e);
            end;
         end;
      6: begin
            // ȉ~f[^\
            with CData.dEll[o2] do begin
               DisplayEllipse(Layer,Color,Ltype,line_width,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,e);
            end;
         end;
      7: begin
            // ȉ~ʃf[^\
            with CData.dEAr[o2] do begin
               DisplayEllipseArc(Layer,Color,Ltype,line_width,Direction,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,start_angle,end_angle,e);
            end;
         end;
      end;
   end;

   // 􉽗vf^}ȉ@ef[^\
   for i:=0 to CData.zFztN-1 do begin
      j := CData.FZukeiNameCheck(0,CData.zFzt[i].name) ;
      if (j = 0) then continue ;
      with CData.fDef[j-1] do begin
         for o:=0 to mOrdN-1 do begin
            o1 := mOrd[o].DataType ;
            o2 := mOrd[o].DataNo ;
            case (o1) of
            1: begin
                  // _}[JEf[^\
                  with mTen[o2] do begin
                     MtxXY(lx1,ly1, start_x,start_y, CData.zFzt[i].mtx);
                     an := rotate_angle/180.0*Pi ;
                     lx2 := start_x + 10.0*Cos(an);
                     ly2 := start_y + 10.0*Sin(an);
                     MtxXY(lx3,ly3, lx2,ly2, CData.zFzt[i].mtx);
                     an  := Angle(lx3-lx1,ly3-ly1);
                     DisplayTenMarker(Layer,Color,marker_code,lx1,ly1,an,Scale);
                  end;
               end;
            2: begin
                  // f[^\
                  with mLin[o2] do begin
                     MtxXY(lx1,ly1, start_x,start_y, CData.zFzt[i].mtx);
                     MtxXY(lx2,ly2, end_x  ,end_y  , CData.zFzt[i].mtx);
                     DisplayLine(Layer,Color,Ltype,line_width,lx1,ly1,lx2,ly2);
                  end;
               end;
            3: begin
                  // ܐf[^\
                  with mLns[o2] do begin
                     SetLength(lx,Number);
                     SetLength(ly,Number);
                     for k:=0 to Number-1 do begin
                        MtxXY(lx[k],ly[k], X[k],Y[k], CData.zFzt[i].mtx);
                     end;
                     DisplayLines(Layer,Color,Ltype,line_width,Number,lx,ly);
                  end;
               end;
            4: begin
                  // ~f[^\
                  with mCir[o2] do begin
                     DisplayCircle(Layer,Color,Ltype,line_width,Center_x,Center_y,Radius,CData.zFzt[i].mtx);
                  end;
               end;
            5: begin
                  // ~ʃf[^\
                  with mArc[o2] do begin
                     DisplayArc(Layer,Color,Ltype,line_width,Direction,Center_x,Center_y,Radius,start_angle,end_angle,CData.zFzt[i].mtx);
                  end;
               end;
            6: begin
                  // ȉ~f[^\
                  with mEll[o2] do begin
                     DisplayEllipse(Layer,Color,Ltype,line_width,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,CData.zFzt[i].mtx);
                  end;
               end;
            7: begin
                  // ȉ~ʃf[^\
                  with mEAr[o2] do begin
                     DisplayEllipseArc(Layer,Color,Ltype,line_width,Direction,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,start_angle,end_angle,CData.zFzt[i].mtx);
                  end;
               end;
            end;
         end;
      end;
   end;
   lx := nil;
   ly := nil;
end;


end.
