unit UnitGraph;

interface

uses
   Graphics, GDIPAPI, GDIPOBJ, Direct2D, D2D1 ;

type
   TGraphClass = class
   public
      { Public 錾 }
      DisplayMode : integer ;    // `惂[h 0:GDI 1:GDI+ 2:Direct2D
      constructor Create;
      destructor Free;
      procedure DataInit;
      procedure SetDisplayMode(m:integer);
      procedure G_Start(C:TCanvas);
      procedure G_End ;
      procedure G_Cls(col:integer) ;
      procedure G_SetPen(col:integer) ;
      procedure G_SetWidth(wid:integer) ;
      procedure G_Line(x1,y1,x2,y2:integer) ;
      procedure G_Circle(x,y,r:integer) ;
      procedure G_CircleF(x,y,r:integer) ;
   private
      { Private 錾 }
      Ca: TCanvas ;
      gra : TGPGraphics;
      pen : TGPPen;
      br0 : TGPSolidBrush;
      D2DCanvas : TDirect2DCanvas ;
      D2Dfa : ID2D1Factory ;
      D2Dss : ID2D1StrokeStyle ;
      D2Dbr : ID2D1Brush;
   end;

implementation

// 
constructor TGraphClass.Create;
begin
   DataInit ;
end;

// 
destructor TGraphClass.Free;
begin
   Ca := nil;
   if (gra <> nil) then begin
      gra.Free;
      gra := nil;
   end;
   if (pen <> nil) then begin
      pen.Free;
      pen := nil;
   end;
   if (br0 <> nil) then begin
      br0.Free;
      br0 := nil;
   end;
   if (D2DCanvas <> nil) then begin
      D2DCanvas.Free;
      D2DCanvas := nil;
   end;
end;

// lZbg
procedure TGraphClass.DataInit;
begin
   DisplayMode := 0;
   Ca := nil;
   gra:= nil;
   pen:= nil;
   br0:= nil;
   D2DCanvas := nil;
end;

// `惂[hݒ
//    m : 0:GDI 1:GDI+ 2:Direct2D
//    Direct2Dg邩ǂ𔻒肵DisplayModeɓ
procedure TGraphClass.SetDisplayMode(m:integer);
begin
   if (m < 0)or(m > 2) then m:=0;
   if (m = 2) then
      if not(TDirect2DCanvas.Supported) then m:=0;
   DisplayMode := m ;
end;

// `Jn
//    C : `
//    `sŏɕKs
procedure TGraphClass.G_Start(C:TCanvas);
begin
   Ca := C ;
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Pen.Color := clBlack;
            Pen.Width := 1;
            Pen.Style := psSolid;
         end;
      end;
   1: begin     // GDI+
         gra := TGPGraphics.Create(Ca.Handle);
         gra.SetSmoothingMode(SmoothingModeHighSpeed);
         pen := TGPPen.Create(MakeColor(255, 0, 0, 0));
         pen.SetWidth(1.0);
         // [ۂݒ
         pen.SetDashStyle(DashStyleSolid);
         pen.SetStartCap(LineCapRound);
         pen.SetEndCap(LineCapRound);
         pen.SetLineJoin(LineJoinRound);
         // uV
         br0 :=TGPSolidBrush.Create(MakeColor(255, 0, 0, 0));
       end;
   2: begin     // Direct2D
         D2DCanvas := TDirect2DCanvas.Create(Ca, Ca.ClipRect);
         with D2DCanvas do begin
            BeginDraw;
            RenderTarget.SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED); // A`GCAX
            Pen.Color := clBlack;
            Pen.Width := 1;
            Pen.Style := psSolid ;
            // [ۂݒ  `RenderTargetɑ΂čs
            RenderTarget.GetFactory(D2Dfa);
            D2Dfa.CreateStrokeStyle(
               D2D1StrokeStyleProperties(D2D1_CAP_STYLE_ROUND,D2D1_CAP_STYLE_ROUND,D2D1_CAP_STYLE_ROUND,
               D2D1_LINE_JOIN_ROUND,10,D2D1_DASH_STYLE_SOLID,0),nil,0,D2Dss);
            D2Dbr := CreateBrush(Pen.Color);
         end;
      end;
   end;
end;

// `I
//    `I鎞ɕKs
procedure TGraphClass.G_End ;
begin
   if (Ca = nil) then exit ;
   case(DisplayMode)of
   1: begin     // GDI+
         pen.Free;   pen := nil;
         br0.Free;   br0 := nil;
         gra.Free;   gra := nil;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            EndDraw;
            Free;
         end;
          D2DCanvas := nil;
      end;
   end;
end;

// ʃNA
//    col : wiF(RGB)
procedure TGraphClass.G_Cls(col:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Brush.Color := col ;
            Brush.Style := bsSolid ;
            Fillrect(ca.ClipRect);
         end;
      end;
   1: begin     // GDI+
         gra.Clear(ColorRefToARGB(col)) ;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.Clear(D2D1ColorF(col));
         end;
      end;
   end;
end;

// yݒ
//    col : \F(RGB)
procedure TGraphClass.G_SetPen(col:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Pen.Color := col ;
            Brush.Color := col ;
         end;
      end;
   1: begin     // GDI+
         pen.SetColor(ColorRefToARGB(col)) ;
         br0.SetColor(ColorRefToARGB(col)) ;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            Pen.Color := col ;
            D2Dbr := CreateBrush(Pen.Color);
         end;
      end;
   end;
end;

// yݒ
//    wid : 
procedure TGraphClass.G_SetWidth(wid:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Pen.Width := wid ;
         end;
      end;
   1: begin     // GDI+
         pen.SetWidth(wid) ;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            Pen.Width := wid ;
         end;
      end;
   end;
end;

// `
//    x1,y1 : n_
//    x2,y2 : I_
procedure TGraphClass.G_Line(x1,y1,x2,y2:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            MoveTo(x1,y1);
            LineTo(x2,y2);
         end;
      end;
   1: begin     // GDI+
         gra.DrawLine(pen, x1,y1, x2,y2);
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.DrawLine(D2D1PointF(x1,y1),D2D1PointF(x2,y2),D2Dbr,Pen.Width,D2Dss);
         end;
      end;
   end;
end;

// ~`
//    x,y : S_
//    r   : a
procedure TGraphClass.G_Circle(x,y,r:integer) ;
begin
   if (r < 1) then r := 1 ;
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Brush.Style := bsClear ;
            Ellipse(x-r,y-r, x+r,y+r);
         end;
      end;
   1: begin     // GDI+
         gra.DrawEllipse(pen, x-r,y-r, r+r,r+r);
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.DrawEllipse(D2D1Ellipse(D2D1PointF(x,y),r,r),D2Dbr,Pen.Width,D2Dss);
         end;
      end;
   end;
end;

// hׂ~`
//    x,y : S_
//    r   : a
procedure TGraphClass.G_CircleF(x,y,r:integer) ;
begin
   if (r < 1) then r := 1 ;
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Brush.Style := bsSolid ;
            Brush.Color := Pen.Color ;
            Ellipse(x-r,y-r, x+r,y+r);
            Brush.Style := bsClear ;
         end;
      end;
   1: begin     // GDI+
         gra.FillEllipse(br0, x-r,y-r, r+r,r+r);
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.FillEllipse(D2D1Ellipse(D2D1PointF(x,y),r,r),D2Dbr);
         end;
      end;
   end;
end;

end.
